## 111.11.00

- Added error locations to `Macro`-expansion errors.

## 110.01.00

- Added `with sexp` support for mutually recursive types with common
  fields.

  For instance:

  ```ocaml
  type a = { fl : float } and b = { fl : int } with sexp
  ```

  Closes #3
- Fixed the behavior of sexplib on `private` types.

  sexplib used to ignore the `private` modifier, which means generated
  functions had the wrong type.  Now, it generates a function with the
  right type for `sexp_of` and refuses to generate anything for
  `of_sexp`.
- Added `Macro.expand_local_macros`, which macro expands sexps,
  failing on `:include` macros.
- Fixed `Macro`'s handling of nested `:include`'s which was broken
  with respect to paths.

  Prior to this fix, `:include`'s were broken with respect to the path
  used to resolve the filename.  Including a file outside the current
  directory which included another file relative to that one would
  break.

## 109.60.00

- Moved unix-specific code to a new object section, sexplib_unix

## 109.53.00

- Changed `sexp_of_float` to (usually) use as few digits as possible,
  without losing precision.
- Split the part of `Sexplib` that depends on `Num` into a separate
  library, `Sexplib_num`.

  This was done to eliminate the dependence of `Core_kernel` on `Num`,
  which is not usable on javascript.

## 109.52.00

- Added a `Macro` module, with `load_sexp*` functions that support
  file includes and templates.

  The following new syntaxes are supported:

  ```ocaml
  (:include filename)
  (:let f (arg1 ... argn) sexp1 ... sexpn)
  (:use f (arg1 valn) ... (argn valn))
  (:concat a1 ... an)
  ```
- Added support to `with sexp` for a subset of GADTs.

  The new support is for types that use existentially quantified
  variables or plain variants written with GADT syntax.

  Existentially quantified variables still have to be wrapped with
  `sexp_opaque` generate compiling code.
- Fixed a type error in the code generated by `with sexp` in some
  cases of variant inclusions.

## 109.20.00

- Renamed converter generated by `with sexp` for polymorphic variants so it is hidden from the toplevel.

  `of_sexp` created a value named `<type>_of_sexp__` to handle
  polymorphic variants.  To hide it from the toplevel, we renamed it as
  `__<type>_of_sexp__`.  We kept the `__` suffix to avoid any confusion
  with a type named `__<type>`.

## 109.12.00

- A tiny lexer improvement in `lexer.mll`.  Used
  `lexbuf.lex_{start|curr}_pos` instead of
  `lexbuf.lex_{start|curr}_p.pos_cnum` for computing the length of a
  lexeme since the difference is the same.

## 109.10.00

- Improved error messages in presence of GADTs.
- Made `with sexp` work with types containing `as` in signatures.

## 109.09.00

- Fixed an `unused rec` warning in the code generated by `pa_sexp` in
  rare cases.

